import stiftUndCo.*;

// Kochsche Kurve

public class KochDruck {
	private Bildschirm bildschirm;
	private BuntStift stift,stift2;
	private Blatt blatt;
	private int rot,grn,blau;

	public static void main(String[] s)
	{
 		KochDruck druckeKoch = new KochDruck();
 		druckeKoch.los(5);	
		druckeKoch.gibFrei();
	}
	
	public void los(int n)	
	{
	 bildschirm = new Bildschirm();/* 1 */	
	 stift2=new BuntStift();
	 stift2.bewegeBis(10,50);
	 stift2.schreibe("Es wird eine Kochsche Kurve gedruckt");
	 blatt = new Blatt();	 				/* 2 */	
	 stift = new BuntStift(blatt);			/* 3 */
	 stift.bewegeBis (100,330);
	 stift.runter();
	 stift.dreheBis(60);
	 figur(n);
	 blatt.drucke();						 /* 4 */
	}

	private void grundfigur ( int n) 
	{
		if (n==1) 
		{ 
			stift.bewegeUm(3.5);
			rot=Hilfe.zufall(0,255);
			grn=Hilfe.zufall(0,255);
			blau=Hilfe.zufall(0,255);
			stift.setzeFarbe(Farbe.rgb(rot,grn,blau));
		} 
		else {
			grundfigur (n-1);
			if (n > 4) { figur(3); }
			stift.dreheUm (60);
			grundfigur (n-1);
			if (n>4) { figur(3); }
			stift.dreheUm (-120);
			grundfigur (n-1);
			if (n>4) { figur(3); }
			stift.dreheUm (60);
			grundfigur (n-1);
			if (n>4) { figur(3); }
		}
	}

	private void figur (int n) {
		for (int i=1;i<4;i++){
		grundfigur (n);
		stift.dreheUm(-120); 
		}
	}

	public void gibFrei()
	{
      if( stift != null)
	  { 
		  stift.gibFrei();
	  }
     if( blatt != null)
	  { 
		  blatt.gibFrei();		 
	  }
	}
}