// Keller.java 

public class Keller {

    

    private KellerElement top;  // zeigt auf obersten KellerElement

    public Keller() {                                  // legt leeren Keller an
        top = null;
    }

    public boolean empty() {                           // liefert true,
        return top == null;                            // falls Keller leer
    }

    public void push(Object x) {                       // legt Objekt x    
        KellerElement hilf = new KellerElement();      // auf den Keller
        hilf.inhalt = x;
        hilf.next   = top;
        top         = hilf;
    }

    public Object top() {                              // liefert oberstes
        if (empty()) {return null;}
		else											//Kellerelement
        {return top.inhalt; }
    }

    public void pop() {									// entfernt oberstes
        if ( ! empty())									// Kellerelement
        { top = top.next;}
    }
}

class KellerElement {
        Object inhalt;          // Inhalt des KellerElements
        KellerElement next;     // zeigt auf naechsten KellerElement
		
}
