import stiftUndCo.*;

public class Ball
{
  private BuntStift stift;
  private Malflaeche bildschirm;
  private double richtung;

  public Ball(Malflaeche pb)
  {
	  this.bildschirm=pb;
	  stift=new BuntStift(pb);
	  stift.bewegeBis(this.bildschirm.breite()/2,this.bildschirm.hoehe()/2);
	  richtung=0; // standardwert
	  stift.dreheBis(richtung);
  }

  public void setzeRichtung(double prichtung)
  {
	  this.richtung=prichtung;
	  stift.dreheBis(richtung);
  }

  public void zeichne()
  {
	  stift.normal();
	  stift.zeichneKreis(20);
  }

  public void lsche()
  {
	  stift.radiere();
	  stift.zeichneKreis(20);
  }

  public void bewege()
  {
	 this.lsche();
	 stift.bewegeUm(1);
	 this.zeichne();
	 if (stift.hPosition()>=this.bildschirm.breite()-20)
	 {
		this.setzeRichtung(180-this.richtung);
	 }
	 if (stift.hPosition()< 20)
	 {
		this.setzeRichtung(180-this.richtung);
	 }
 	 if (stift.vPosition()>=this.bildschirm.hoehe()-20)
	 {
		this.setzeRichtung(-this.richtung);
	 }
	 if (stift.vPosition()< 20)
	 {
		this.setzeRichtung(-this.richtung);
	 } }
  public void gibFrei()
  {
	  this.lsche();
	  stift.gibFrei();
  }
}
	