import stiftUndCo.*;
import java.awt.*;

//
//
// Rechteck
//
//
public class Rechteck extends GrafikObjekt
{
    private double zbreite,zhoehe;
    private double zhpos,zvpos;

	public Rechteck()
	{
			this(0,0,10,10);
		
	}

    public Rechteck(double linksobenx, double linksobeny, double breite, double hhe)
	{
			super();
			zbreite=breite;
			zhoehe=hhe;
			zhpos=linksobenx;
			zvpos=linksobeny;
	}
	

  

	public void bewegeUm(double dx, double dy)
	{
		if ( this.sichtbar() )
		{
			this.setzeSichtbar(false);
			zhpos=zhpos+dx;
			zvpos=zvpos+dy;
			this.setzeSichtbar(true);
		}
		else
		{
			zhpos=zhpos+dx;
			zvpos=zvpos+dy;
		}
	}

	public void zeige()
	{
		
		this.stift().setzeStandard();
		this.stift().bewegeBis(zhpos,zvpos);
		this.stift().setzeFarbe(this.farbe());
		if (this.aktiv()) { this.stift().wechsle(); }
		this.stift().zeichneRechteck(zbreite,zhoehe);
	}

	public void loesche()
	{
		if (this.aktiv()) { this.zeige();}
		else
		{
		 this.stift().setzeStandard();
		 this.stift().radiere();
		 this.stift().bewegeBis(zhpos,zvpos);
		 this.stift().zeichneRechteck(zbreite,zhoehe);
		}
	}

	public boolean istDrin(double px, double py)
	{
		return (zhpos<=px) && (zhpos+zbreite >= px)
				&& (zvpos<=py) && (zvpos+zhoehe >= py);
	}

	public void setzePosition(double x, double y)
	{
		if ( this.sichtbar() )
		{
			this.setzeSichtbar(false);
			zhpos=x;
			zvpos=y;
			this.setzeSichtbar(true);
		}
		else
		{
			zhpos=x;
			zvpos=y;
		}
	}


	public double hPosition()
	{
		return zhpos;
	}

	public double vPosition()
	{
		return zvpos;
	}

	public void setzeBreite(double pb)
	{
		if ( this.sichtbar() )
		{
			this.setzeSichtbar(false);
			zbreite=pb;
			this.setzeSichtbar(true);
		}
		else
		{
		zbreite=pb;
		}
	}

	public double breite()
	{
		return zbreite;
	}

	public void setzeHoehe(double ph)
	{
		if ( this.sichtbar() )
		{
			this.setzeSichtbar(false);
			zhoehe=ph;
			this.setzeSichtbar(true);
		}
		else
		{
			zhoehe=ph;
		}
	}

	public double hoehe()
	{
		return zhoehe;
	}

}