import stiftUndCo.*;
import java.awt.*;
public class Gueterwagen extends Waggon
{
	Rechteck aufbau;
	Kreis rad1, rad2;
	public Gueterwagen (double pHPosition, double pVPosition)
	{
		super(pHPosition, pVPosition);
		aufbau= new Rechteck(55, 30, pHPosition, pVPosition - 30, Farbe.BLAU);
		rad1=new Kreis(5, pHPosition + 10, pVPosition,Farbe.ROT);
		rad2=new Kreis(5, pHPosition + 45, pVPosition, Farbe.ROT);
	}
	public Gueterwagen (double pHPosition, double pVPosition,Malflaeche m)
	{
		super(pHPosition, pVPosition,m);
		aufbau= new Rechteck(55, 30, pHPosition, pVPosition - 30, Farbe.BLAU,m);
		rad1=new Kreis(5, pHPosition + 10, pVPosition,Farbe.ROT,m);
		rad2=new Kreis(5, pHPosition + 45, pVPosition, Farbe.ROT,m);
	}
	

	public void zeichneDich()
	{
		super. zeichneDich();
		rad1.zeichneDich();
		rad2.zeichneDich();
		aufbau.zeichneDich();
	}

	public void loescheDich()
	{
		super. loescheDich();
		rad1.loescheDich();
		rad2.loescheDich();
		aufbau.loescheDich();
	}

	public void bewegeBis (double pHPosition,double  pVPosition)
	{
		super. bewegeBis(pHPosition, pVPosition);
		rad1.bewegeBis(pHPosition + 10, pVPosition);
		rad2.bewegeBis(pHPosition + 45, pVPosition);
		aufbau.bewegeBis(pHPosition, pVPosition - 30);
	}

	public double laenge()
	{
		return 55;
	}

	public void gibFrei()
	{
		aufbau.gibFrei();
		rad2.gibFrei();
		rad1.gibFrei();
		super. gibFrei();
	}
}