import stiftUndCo.*;
import java.awt.*;

public class Personenwagen extends Waggon
{
	Rechteck wagen, tuer;
	Quadrat fenster1, fenster2;
	Kreis rad1, rad2;
	public Personenwagen (double pHPosition,double  pVPosition)
	{
		super(pHPosition, pVPosition);
		wagen = new Rechteck(50, 30, pHPosition, pVPosition - 30, Farbe.BLAU);
		tuer =new Rechteck(10, 25, pHPosition + 20, pVPosition - 25, Farbe.BLAU);
		rad1 =new Kreis(5, pHPosition + 10, pVPosition, Farbe.ROT);
		rad2 = new Kreis(5, pHPosition + 40, pVPosition, Farbe.ROT);
		fenster1 = new Quadrat(10, pHPosition + 5, pVPosition - 25, Farbe.SCHWARZ);
		fenster2 = new Quadrat(10, pHPosition + 35, pVPosition - 25, Farbe.SCHWARZ);
	}
	public Personenwagen (double pHPosition,double  pVPosition,Malflaeche m)
	{
		super(pHPosition, pVPosition,m);
		wagen = new Rechteck(50, 30, pHPosition, pVPosition - 30, Farbe.BLAU,m);
		tuer =new Rechteck(10, 25, pHPosition + 20, pVPosition - 25, Farbe.BLAU,m);
		rad1 =new Kreis(5, pHPosition + 10, pVPosition, Farbe.ROT,m);
		rad2 = new Kreis(5, pHPosition + 40, pVPosition, Farbe.ROT,m);
		fenster1 = new Quadrat(10, pHPosition + 5, pVPosition - 25, Farbe.SCHWARZ,m);
		fenster2 = new Quadrat(10, pHPosition + 35, pVPosition - 25, Farbe.SCHWARZ,m);
	}

	public double laenge()
	{
		return 50;
	}

	public void zeichneDich()
	{
		super. zeichneDich();
		wagen.zeichneDich();
		tuer.zeichneDich();
		rad1.zeichneDich();
		rad2.zeichneDich();
		fenster1.zeichneDich();
		fenster2.zeichneDich();
	}

	public void loescheDich()
	{
		super. loescheDich();
		wagen.loescheDich();
		tuer.loescheDich();
		rad1.loescheDich();
		rad2.loescheDich();
		fenster1.loescheDich();
		fenster2.loescheDich();
	}

	public void bewegeBis (double pHPosition,double  pVPosition)
	{
		super. bewegeBis(pHPosition, pVPosition);
		wagen.bewegeBis(pHPosition, pVPosition - 30);
		tuer.bewegeBis(pHPosition + 20, pVPosition - 25);
		rad1.bewegeBis(pHPosition + 10, pVPosition);
		rad2.bewegeBis(pHPosition + 40, pVPosition);
		fenster1.bewegeBis(pHPosition + 5, pVPosition - 25);
		fenster2.bewegeBis(pHPosition + 35, pVPosition - 25);
	}

	public void gibFrei()
	{
		fenster1.gibFrei();
		fenster2.gibFrei();
		rad2.gibFrei();
		rad1.gibFrei();
		tuer.gibFrei();
		wagen.gibFrei();
		super. gibFrei();
	}
}
